﻿using System;
using System.Windows;
using System.ComponentModel;
using Microsoft.Phone.Controls;
using System.Collections.ObjectModel;

namespace LoadingDataDemo
{
    public partial class MainPage : PhoneApplicationPage, INotifyPropertyChanged
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            App.ViewModel.More.PageLstModelCount = 0;
            SelfModel = new ObservableCollection<SimpleModel>();

            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            DataContext = App.ViewModel;
            LstBox.ItemsSource = Model;
        }

        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            if (!App.ViewModel.IsDataLoaded)
            {
                App.ViewModel.LoadData();
            }
            LoadData15();
            base.OnNavigatedTo(e);
        }

        private void ApplicationBarIconButton_Click(object sender, EventArgs e)
        {
            foreach (var item in LstBox.SelectedItems)
            { 
                if(item is SimpleModel)
                {
                    Model.Remove((SimpleModel)item);
                    App.ViewModel.LstModel.Remove((SimpleModel)item);
                }
            }
            App.ViewModel.More.PageLstModelCount = 0;
            Model.Clear();
            LoadData15();
        }

        private void ApplicationBarIconButton_Click_1(object sender, EventArgs e)
        {
            LstBox.SelectAll();
        }

        private void Buton_Click(object sender, RoutedEventArgs e)
        {
            LoadData15();
        }

        private ObservableCollection<SimpleModel> SelfModel = null;
        public ObservableCollection<SimpleModel> Model
        {
            get { return SelfModel; }
            set
            {
                SelfModel = value;
                NotifyPropertyChanged("Model");
            }
        }

        private void LoadData15()
        {
            for (int i = 0; i < 8; i++)
            {
                if (App.ViewModel.More.PageLstModelCount < App.ViewModel.LstModel.Count)
                {
                    Model.Add(App.ViewModel.LstModel[App.ViewModel.More.PageLstModelCount]);
                    App.ViewModel.More.PageLstModelCount++;
                }
                else
                { 
                    return;
                }
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;
        protected void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}