﻿using System;
using System.ComponentModel;

namespace LoadingDataDemo
{
    public class SimpleModel : INotifyPropertyChanged
    {
        /// <summary>
        /// name or title
        /// </summary>
        protected string SelfName = string.Empty;
        public string Name 
        {
            get { return SelfName; }
            set 
            {
                SelfName = value;
                NotifyPropertyChanged("Name");
            }
        }

        /// <summary>
        /// fuction description 
        /// </summary>
        protected string SelfDescription = string.Empty;
        public string Discription
        {
            get { return SelfDescription; }
            set 
            {
                SelfDescription = value;
                NotifyPropertyChanged("Discription");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void NotifyPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}